﻿using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Threading.Tasks;
using HunterPaxxx.Helpers;

#region Redundancy
using L = HunterPaxxx.Helpers.Log;
using U = HunterPaxxx.Core.Unit;
#endregion

namespace HunterPaxxx.Core
{
    class Spell
    {
        public static int lastSpellCast;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        //Cooldown Detection
        public static double cooldownTimeLeft(int Spell)
        {
            try
            {
                SpellFindResults Results;
                return SpellManager.FindSpell(Spell, out Results) ? (Results.Override != null ? Results.Override.CooldownTimeLeft.TotalMilliseconds : Results.Original.CooldownTimeLeft.TotalMilliseconds) : 9999;
            }
            catch (Exception xException)
            {
                Log.diagnosticsLog("Exception in cooldownTimeLeft(); ", xException);
                return 0000;
            }
        }

        public static bool onCooldown(int Spell)
        {
            try
            {
                SpellFindResults Results;
                if (SpellManager.FindSpell(Spell, out Results)) { return Results.Override != null ? Results.Override.Cooldown : Results.Original.Cooldown; }
                return false;
            }
            catch (Exception xException)
            {
                Log.diagnosticsLog("Exception in cooldownTimeLeft(); ", xException);
                return false;
            }
        }

        //Casting
        public static async Task<bool> Buff(int Spell, bool reqs)
        {
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), Me, false, false, false)) //Should we check for if we are moving? *Second false
                return false;
            if (!SpellManager.Cast(Spell, Me))
                return false;
            lastSpellCast = Spell;
            Log.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static async Task<bool> Cast(int Spell, bool reqs)
        {

            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), currentTarget, false, false, false)) //Should we check for if our currentTarget is moving? *Second false
                return false;
            if (!SpellManager.Cast(Spell, currentTarget))
                return false;
            lastSpellCast = Spell;
            Log.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static async Task<bool> GCD(int Spell, bool reqs)
        {
            if (onCooldown(Spell))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.Cast(Spell))
                return false;
            lastSpellCast = Spell;
            Log.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static TimeSpan GetSpellCastTime(WoWSpell spell)
        {
            if (spell != null)
            {
                int time = (int)spell.CastTime;
                if (time == 0)
                    time = spell.BaseDuration;
                return TimeSpan.FromMilliseconds(time);
            }

            return TimeSpan.Zero;
        }

        #region Spell Charges

        public static int GetCharges(string name)
        {
            SpellFindResults sfr;
            if (SpellManager.FindSpell(name, out sfr))
            {
                WoWSpell spell = sfr.Override ?? sfr.Original;
                return GetCharges(spell);
            }
            return 0;
        }


        public static int GetCharges(WoWSpell spell)
        {
            int charges = Lua.GetReturnVal<int>("return GetSpellCharges(" + spell.Id.ToString() + ")", 0);
            return charges;
        }
        #endregion



    }
}
