﻿using Styx;
using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using HunterPaxxx.Helpers;

#region Redundancy
using L = HunterPaxxx.Helpers.Log;
using S = HunterPaxxx.Core.Spell;
using SB = HunterPaxxx.Helpers.SpellBook;
#endregion

namespace HunterPaxxx.Core
{
    class Unit
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }


        //Active Enemies
        public static IEnumerable<WoWUnit> activeEnemies(Vector3 fromLocation, double Range)
        {
            var Hostile = enemyCount;
            return Hostile != null ? Hostile.Where(x => x.Location.DistanceSqr(fromLocation) <= Range * Range) : null;


        }

        private static List<WoWUnit> enemyCount { get; set; }
        public static List<WoWUnit> petCount { get; set; }


        public static void enemyAnnex(double Range)
        {
            enemyCount.Clear();
            foreach (var u in surroundingEnemies())
            {
                if (u == null || !u.IsValid)//<~ Use isUnitValid(u, Range) instead of the frist five of these first calls?
                    continue;
                if (!u.IsAlive || u.DistanceSqr > Range * Range)
                    continue;
                if (!u.Attackable || !u.CanSelect)
                    continue;
                if (u.IsFriendly)
                    continue;
                if (u.IsNonCombatPet && u.IsCritter)
                    continue;
                enemyCount.Add(u);
            }
        }

        private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }
        private static IEnumerable<WoWUnit> surroundingPets() { return ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => u != null && u.CreatedByUnitGuid == Me.Guid); }

        static Unit()
        {
            enemyCount = new List<WoWUnit>();
            petCount = new List<WoWUnit>();
        }


        //Aura Detection
        public static bool auraExists(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            }
            catch (Exception xException)
            {
                Log.diagnosticsLog("Exception in auraExists(); ", xException);
                return false;
            }
        }

        public static uint auraStacks(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.StackCount : 0;
            }
            catch (Exception xException)
            {
                Log.diagnosticsLog("Exception in auraStacks(); ", xException);
                return 0;
            }
        }

        public static double auraTimeLeft(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            }
            catch (Exception xException)
            {
                Log.diagnosticsLog("Exception in auraExists(); ", xException);
                return 9999;
            }
        }

        #region Cache


        private const int BannerOfTheAlliance = 61573;
        private const int BannerOfTheHorde = 61574;


        public static void Cache()
        {

        }
        #endregion

        //Unit Eval

        public static bool isUnitValid(WoWUnit Unit, double Range)
        {
            int bannerId = StyxWoW.Me.IsHorde ? BannerOfTheAlliance : BannerOfTheHorde;
            if (Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && Unit.DistanceSqr <= Range * Range)

                return true;
            if (Unit != null && Unit.Level > 1 && ((Unit.CurrentHealth == 1 && Unit.MaxHealth < Unit.Level) || Unit.HasAura(bannerId) || Unit.Name.Contains("Trainingsattrappe")))
                return true;
            else return false;
        }
        public static double luaGetPower()
        {
            try
            {
                using (StyxWoW.Memory.AcquireFrame()) { return Lua.GetReturnVal<int>("return UnitPower(\"player\");", 0); }
            }
            catch (Exception xException)
            {
                Log.diagnosticsLog("Exception in playerPower(); ", xException);
                return Me.CurrentPower;
            }
        }

    }
}
