﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;

using Styx.WoWInternals.WoWObjects;
using System;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.IO;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Windows.Media;

using HunterPaxxx.Core;
using HunterPaxxx.Managers;
using HunterPaxxx.Rotation;
using HunterPaxxx.Helpers;
using Honorbuddy;
using Styx.WoWInternals;
using MahApps.Metro;
using MahApps.Metro.Controls;
using Styx.Helpers;
using Styx.Plugins;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using Styx.TreeSharp;
using Action = System.Action;

#region Redundancy
using HK = HunterPaxxx.Managers.Hotkeys;
using C = HunterPaxxx.Rotation.Combat;
using U = HunterPaxxx.Core.Unit;
#endregion

namespace HunterPaxxx
{
    class Main : CombatRoutine

    {

        public static Configuration Config;
        public static readonly Version version = new Version(1, 5, 5);
        public override string Name { get { return "[HunterPaxxx] v" + version; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public override WoWClass Class { get { return WoWClass.Hunter; } }

        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => C.combatBuffing()); } }
        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => C.rotationSelector()); } }
        // TRAININGS DUMMY WORKAROUND ->
        // public override Composite RestBehavior { get { return new ActionRunCoroutine(ctx => C.rotationSelector()); } }

        public override void Initialize()
        {
            Logging.Write(Colors.Purple, "HUNTER PAXXX");
            Logging.Write(Colors.Purple, "-- v" + version + " --");
            Logging.Write(Colors.Purple, "-- By paxxx --");
            Logging.Write(Colors.Purple, "-- A Markmanship Hunter Combat Routine for MaxDPS in RAIDS--");

            System.Windows.Application.Current.Dispatcher.BeginInvoke((Action)(() =>
            {
                var grid = (Grid)((MainWindow)Application.Current.MainWindow).Content;
                var profileConfigButton = grid.Children.OfType<Button>().FirstOrDefault(btn => btn.Name == "btnHP");
                if (profileConfigButton != null) return;
                var button = new Button
                {
                    Name = "btnHP",
                    HorizontalAlignment = HorizontalAlignment.Right,
                    VerticalAlignment = VerticalAlignment.Center,
                    Margin = new Thickness(0, 0, 8, 55),
                    Content = "HunterPaxxx",
                    Height = 20,
                    Width = 120
                };
                button.Click += Button_Click;
                grid.Children.Add(button);
            }));


            Hotkeys.registerHotkeys();
        }

        public override bool WantButton => true;


        public override void OnButtonPress()
        {
            if (Config == null)
                Config = new Configuration("Hunterpaxxx Configuration", "1.5.5", "by paxxx", 600, 400);
            ThemeManager.ChangeAppStyle(Config, ThemeManager.GetAccent("Cobalt"), ThemeManager.GetAppTheme("BaseDark"));
            Config.Show();
            Config.Closed += config_Closed;
        }

        private void Button_Click(object sender, EventArgs e)
        {
            OnButtonPress();
        }

        private void config_Closed(object sender, EventArgs e)
        {
            Settings.Instance.Save();
            Config = null;
            Hotkeys.removeHotkeys();
            Hotkeys.registerHotkeys();
        }

        public class Settings : Styx.Helpers.Settings
        {
            public static readonly string _settingsPath = Path.Combine(CharacterSettingsDirectory, "HunterPaxxx",
                "HunterPaxxx_Config.xml");

            private static Settings _instance;

            public Settings() : base(_settingsPath)
            {
            }

            public static Settings Instance => _instance ?? (_instance = new Settings());


            [Setting]
            [Category("Configuration")]
            [DisplayName("Hotkey for Cooldowns (Trueshot):   ALT-")]
            [Styx.Helpers.DefaultValue("C")]
            public String CooldownsHotkey { get; set; }

            [Setting]
            [Category("Configuration")]
            [DisplayName("Hotkey for Barrage Usage:   ALT-")]
            [Styx.Helpers.DefaultValue("B")]
            public String CooldownsBarrage { get; set; }

            [Setting]
            [Category("Configuration")]
            [DisplayName("Hotkey for Manual Mode:   ALT-")]
            [Styx.Helpers.DefaultValue("M")]
            public String CooldownsManualMode { get; set; }

            [Setting]
            [Category("Configuration")]
            [DisplayName("Hotkey for AOE Mode (casting Marked Shot as available):   ALT-")]
            [Styx.Helpers.DefaultValue("A")]
            public String AoEMode { get; set; }

        }

        public override void ShutDown() { Hotkeys.removeHotkeys(); }

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (!StyxWoW.IsInGame || !StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            Unit.Cache();
            Unit.enemyAnnex(46f); //<~ Set this to whatever our smallest AoE spell's range is

            //Fps Ensure
            DateTime ct = new DateTime();

            if (DateTime.Now.Subtract((DateTime)ct).TotalMilliseconds >= 50)
            {
                if (StyxWoW.WoWClient.Fps <= 15)
                {
                    if (TreeRoot.TicksPerSecond > 5)
                    {
                        TreeRoot.TicksPerSecond = 5;
                        ct = DateTime.Now;
                    }
                }
                else if (TreeRoot.TicksPerSecond < 30 && DateTime.Now.Subtract((DateTime)ct).TotalMilliseconds >= 500)
                {
                    TreeRoot.TicksPerSecond += 1;
                    ct = DateTime.Now;
                }
            }
        }
        #endregion

        public override CapabilityFlags SupportedCapabilities
        {
            get { return CapabilityFlags.Aoe | CapabilityFlags.DefensiveCooldowns | CapabilityFlags.GapCloser | CapabilityFlags.OffensiveCooldowns | CapabilityFlags.SpecialAttacks; }
        }



    }




}




