﻿using System;
using Styx;
using Styx.Common;
using System.Windows.Forms;
using System.Windows.Media;

namespace HunterPaxxx.Managers
{
    class Hotkeys
    {
        public static bool AoEOn { get; set; }
        public static bool cooldownsOn { get; set; }
        public static bool manualOn { get; set; }
        public static bool keysRegistered { get; set; }
        public static bool barrageOn { get; set; }
        public static bool AoEMode { get; set; }

        public static Keys ConvertFromString(string keystr)
        {
            return (Keys)Enum.Parse(typeof(Keys), keystr);
        }

        public static void registerHotkeys()
        {
            if (keysRegistered)
                return;

            HotkeysManager.Register("cooldownsOn", ConvertFromString(Main.Settings.Instance.CooldownsHotkey), ModifierKeys.Alt, ret =>
            {
                cooldownsOn = !cooldownsOn;
                StyxWoW.Overlay.AddToast((cooldownsOn ? "Cooldowns: Enabled!" : "Cooldowns: Disabled!"), 2000);
            });
            HotkeysManager.Register("ManualOn", ConvertFromString(Main.Settings.Instance.CooldownsManualMode), ModifierKeys.Alt, ret =>
            {
                manualOn = !manualOn;
                StyxWoW.Overlay.AddToast((manualOn ? "Manual Mode: Enabled!" : "Manual Mode: Disabled!"), 2000);
            });
            HotkeysManager.Register("barrageOn", ConvertFromString(Main.Settings.Instance.CooldownsBarrage), ModifierKeys.Alt, ret =>
            {
                barrageOn = !barrageOn;
                StyxWoW.Overlay.AddToast((barrageOn ? "Barrage Usage: Enabled!" : "Barrage Usage: Disabled!"), 2000);
            });
            HotkeysManager.Register("AoEMode", ConvertFromString(Main.Settings.Instance.AoEMode), ModifierKeys.Alt, ret =>
            {
                AoEMode = !AoEMode;
                StyxWoW.Overlay.AddToast((AoEMode ? "AoE Mode: Enabled!" : "AoE Mode: Disabled!"), 2000);
            });

            keysRegistered = true;
            cooldownsOn = true;
            manualOn = false;
            barrageOn = true;
            AoEMode = false;
            //StyxWoW.Overlay.AddToast(("Hotkeys: Registered!"), 2000);
            Logging.Write(Colors.Green, "Hotkeys: Registered!");
        }

        public static void removeHotkeys()
        {
            if (!keysRegistered)
                return;
            HotkeysManager.Unregister("cooldownsOn");
            HotkeysManager.Unregister("manualOn");
            HotkeysManager.Unregister("barrageOn");
            HotkeysManager.Unregister("AoEMode");
            cooldownsOn = false;
            manualOn = false;
            barrageOn = false;
            keysRegistered = false;
            AoEMode = false;
            //  StyxWoW.Overlay.AddToast(("Hotkeys: Removed!"), 2000);
            Logging.Write(Colors.Purple, "Hotkeys: Removed!");
        }
    }
}

