﻿using System;
using Styx;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.Linq;
using System.Threading.Tasks;
using HunterPaxxx.Core;
using HunterPaxxx.Helpers;
using HunterPaxxx.Managers;
using Styx.Common;

#region Redundancy
using HK = HunterPaxxx.Managers.Hotkeys;
using S = HunterPaxxx.Core.Spell;
using SB = HunterPaxxx.Helpers.SpellBook;
using U = HunterPaxxx.Core.Unit;
using L = HunterPaxxx.Helpers.Log;
#endregion

namespace HunterPaxxx.Rotation
{
    class Combat
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        //Combat Buffing
        public static async Task<bool> combatBuffing()
        {

            if (Hotkeys.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            return await Spell.Cast(0, true);
        }

        //Rotation
        public static async Task<bool> rotationSelector()
        {

            if (Hotkeys.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            else if (Unit.activeEnemies(Me.Location, 8f).Count() > 1 && await AoE()) return true;
            return await singleTarget();
        }

        //AoE
        public static async Task<bool> AoE()
        {


            return await singleTarget();

        }

        //Single Target
        public static async Task<bool> singleTarget()
        {

            // Marked Shot to maintain Vulnerable.
            // Barrage on cooldown(if selected).
            // Aimed Shot with >= 2 sec on Vulnerable.Watch for Lock and Load procs(if selected).
            // Aimed Shot to dump excess Focus.
            // Sidewinders to consume Marking Targets or at 2(if selected).

            // CDs
            if (await Spell.Cast(SpellBook.markedshot, Hotkeys.AoEMode && Unit.isUnitValid(currentTarget, 47)))
                return true;
            if (await Spell.Cast(SpellBook.volltreffer, Hotkeys.cooldownsOn && Unit.isUnitValid(currentTarget, 47))) return true;
            if (await Spell.Cast(SpellBook.barrage, Hotkeys.barrageOn && Unit.isUnitValid(currentTarget, 47))) return true;
            if (await Spell.Cast(SpellBook.dievoegel, Unit.isUnitValid(currentTarget, 47))) return true;
            // rotation
            // if (await Spell.Cast(SpellBook.markedshot, Unit.isUnitValid(currentTarget, 47) && currentTarget.HasAura(SpellBook.huntersmark)
            //               && (!currentTarget.HasAura(SpellBook.vulnerable) || (GetAuraTimeLeft(SpellBook.vulnerable).TotalSeconds < 2))

            if (
                await
                    Spell.Cast(SpellBook.markedshot,
                        Unit.isUnitValid(currentTarget, 47) && currentTarget.HasAura(SpellBook.huntersmark)
                        && GetAuraTimeLeft(SpellBook.vulnerable).TotalSeconds < 3.0
                        ))
            {
                //   Logging.Write("Vulnerable time left under 3 second on Target: " + GetAuraTimeLeft(SpellBook.vulnerable).TotalSeconds + " - so I am casting Marked Shot");
                return true;

            }
            if (await Spell.Cast(SpellBook.windburst, Unit.isUnitValid(currentTarget, 47))) return true;
            if (await Spell.Cast(SpellBook.aimedshot, Unit.isUnitValid(currentTarget, 47) &&
                                                      Me.HasAura(SpellBook.lockandload) &&
                                                      currentTarget.HasAura(SpellBook.vulnerable)))
            {
                // Logging.Write("I got Lock N Load! So I am getting Aimed Shot out now!");
                return true;
            }
            if (await Spell.Cast(SpellBook.aimedshot, Unit.isUnitValid(currentTarget, 47) &&
                                                      (GetAuraTimeLeft(SpellBook.vulnerable).TotalSeconds >
                                                       Spell.GetSpellCastTime(WoWSpell.FromId(SpellBook.aimedshot))
                                                           .TotalSeconds)))
            {
                //  Logging.Write("Vulnerable time left on Target: " + GetAuraTimeLeft(SpellBook.vulnerable).TotalSeconds + " and my casting time for Aimed Shot:" + Spell.GetSpellCastTime(WoWSpell.FromId(SpellBook.aimedshot)).TotalSeconds);
                return true;

            }
            if (await Spell.Cast(SpellBook.sidewinders, Unit.isUnitValid(currentTarget, 47) && Me.HasAura(SpellBook.markingtargets))) return true;
            if (await Spell.Cast(SpellBook.sidewinders, Unit.isUnitValid(currentTarget, 47) && (Spell.GetCharges(WoWSpell.FromId(SpellBook.sidewinders))) >= 1) && !currentTarget.HasAura(SpellBook.vulnerable)) return true;
            if (await Spell.Cast(SpellBook.sidewinders, Unit.isUnitValid(currentTarget, 47) && (Spell.GetCharges(WoWSpell.FromId(SpellBook.sidewinders))) == 2)) return true;
            // if (await Spell.Cast(SpellBook.sidewinders, Unit.isUnitValid(currentTarget, 47) && (Spell.GetCharges(WoWSpell.FromId(SpellBook.sidewinders))) >= 1)) return true;
            if (await Spell.Cast(SpellBook.aimedshot, Unit.isUnitValid(currentTarget, 47) && Me.FocusPercent > 145)) return true;
            return true;

        }

        public static TimeSpan GetAuraTimeLeft(int auraID, bool fromMyAura = true)
        {
            if (currentTarget == null)
                return TimeSpan.Zero;

            WoWAura wantedAura = currentTarget.GetAllAuras()
                .Where(a => a.SpellId == auraID && a.TimeLeft > TimeSpan.Zero && (!fromMyAura || a.CreatorGuid == StyxWoW.Me.Guid)).FirstOrDefault();

            return wantedAura != null ? wantedAura.TimeLeft : TimeSpan.Zero;
        }

    }
}

